#ifndef _MTPTRQUEUE_H
#define _MTPTRQUEUE_H

#include <winbase.h>
#include <windows.h>
#include <winnt.h>
#include "stdafx.h"

class MTPtrQueue
{
public:
	MTPtrQueue()
	{
		InitializeCriticalSection(&m_lock);
		m_cond=CreateEvent(NULL,TRUE,FALSE,NULL);
	}

	void push(void *ptr)
	{
		lock();
		m_list.AddHead(ptr);
		SetEvent(m_cond);
		unlock();
	}

	void *pop()
	{
		void *retvalue;

tryagain:
		WaitForSingleObject(m_cond,INFINITE);
		lock();
		if (m_list.IsEmpty()) // did someone grab it from underneath us?
		{
			unlock();
			goto tryagain;
		}

		retvalue=m_list.RemoveHead();
		if (m_list.IsEmpty())
			ResetEvent(m_cond);
		unlock();

		return retvalue;
	}

protected:
	void lock()
	{
		EnterCriticalSection(&m_lock);
	}

	void unlock()
	{
		LeaveCriticalSection(&m_lock);
	}

	CPtrList m_list;
	CRITICAL_SECTION  m_lock;
	HANDLE m_cond;
};

#endif